private import etc.c.zlib;
private import bga_melter;

void inflate( Filep inf, uint csz, Filep otf, uint usz )
{
	ubyte[]  inbuf;  inbuf.length = 65536;
	ubyte[] outbuf; outbuf.length = 65536;

	// zlib
	z_stream zs;
	zs.zalloc   = null;
	zs.zfree    = null;

	// o̓obt@
	zs.next_out  = outbuf;
	zs.avail_out = outbuf.length;

	// ̓obt@
	inbuf = cast(ubyte[]) inf.read( csz<65536 ? csz : 65536 );
	csz        -= inbuf.length;
	zs.next_in  = inbuf;
	zs.avail_in = inbuf.length;

	// X^[g
	inflateInit2( &zs, -15 );

	// ɂ͂I܂Ń[v
	int err = Z_OK;
	while( csz&&usz )
	{
		while( zs.avail_out > 0 )
		{
			err = etc.c.zlib.inflate( &zs, Z_PARTIAL_FLUSH );
			if( err!=Z_STREAM_END && err!=Z_OK )
				csz=0;
			if( !csz )
				break;

			if( zs.avail_in<=0 )
			{
				inbuf = cast(ubyte[]) inf.read( csz<65536 ? csz : 65536 );
				csz        -= inbuf.length;
				zs.next_in  = inbuf;
				zs.avail_in = inbuf.length;

				if( inbuf.length==0 )
				{
					err = Z_STREAM_END;
					csz = 0;
					break;
				}
			}
		}

		int written = outbuf.length - zs.avail_out;
		if( usz < written ) written = usz;
		usz -= written;
		otf.write( outbuf[0..written] );
		zs.next_out  = outbuf;
		zs.avail_out = outbuf.length;
	}

	// o͎c𖳂B
	while( err!=Z_STREAM_END&&usz )
	{
		err = etc.c.zlib.inflate(&zs,Z_PARTIAL_FLUSH);
		if( err!=Z_STREAM_END && err!=Z_OK )
			break;

		int written = outbuf.length - zs.avail_out;
		if( usz < written ) written = usz;
		usz -= written;
		otf.write( outbuf[0..written] );
		zs.next_out  = outbuf;
		zs.avail_out = outbuf.length;
	}

	// I
	inflateEnd(&zs);
}
